This is a guideline of the HTML/CSS/Javascript. It also includes an example that strictly follows this guideline.

# CSS

## Naming Convention

For CSS class naming, we use [BEM](https://en.bem.info/) so that we can be sure that which rule will affect which part and also which rule will NOT affect any unintended part.

Once tring BEM seriously in a complicated web site, we often face similar questions. Here are resources to answer such questions.

* https://www.smashingmagazine.com/2016/06/battling-bem-extended-edition-common-problems-and-how-to-avoid-them/
* http://csswizardry.com/2013/01/mindbemding-getting-your-head-round-bem-syntax/

## Preprocessor : LESS

We use [LESS](http://lesscss.org) for faster development of CSS and also for easier maintenance, like changing colours at once etc.

Here are some guidelines of the usage of LESS :

* You can use the latest released version, i.e. the latest syntax.
* You don't need to care the size of generated CSS. We can anyway use optimiser to grouping similar rules.
* If you are not sure which you should choose between 'mixin' and 'extend', always use 'mixin'.

## Grid : Flexbox

Flexbox is currently [well supported](http://caniuse.com/#feat=flexbox). Use Flexbox as much as possible instead of fighting with float.

## Vendor prefix etc. : Pleeease

We use [Pleeease](pleeease.io). See gulpfile.js.

# JavaScript

Here are some guidelines of the usage of JavaScript :

* Never try tricky things with JavaScript in Form appearance, that may easily break browser compatibility.
* JQuery is available. Feel free to use it as much as possible for better readability and maintainability of the code.

# Fonts

Use [Google Fonts](https://fonts.google.com/) (or any web fonts available on CDN) for better performance.

# Icons

Use [Font Awesome](http://fontawesome.io/) (or any iconic fonts available on CDN) for better performance.
